## c-blosc2 2.13.1+ds

=== examples/CMakeLists.txt ===
# Examples with correspondingly named source files
set(EXAMPLES contexts instrument_codec delta_schunk_ex multithread simple frame_metalayers
    noinit find_roots schunk_simple frame_simple schunk_postfilter urcodecs urfilters frame_vlmetalayers
    sframe_simple frame_backed_schunk compress_file frame_offset frame_roundtrip get_set_slice get_blocksize)

add_subdirectory(b2nd)

if(NOT DEACTIVATE_ZSTD)
    set(EXAMPLES ${EXAMPLES} zstd_dict)
endif()

if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
    # frame_big uses containers of more than 4 GB and cannot run on 32-bit platforms
    list(APPEND EXAMPLES frame_big)
endif()

# targets
foreach(example ${EXAMPLES})
    add_executable(${example} ${example}.c)
    # Define the BLOSC_TESTING symbol so normally-hidden functions
    # aren't hidden from the view of the test programs.
    set_property(
            TARGET ${example}
            APPEND PROPERTY COMPILE_DEFINITIONS BLOSC_TESTING)
endforeach()

if(UNIX AND NOT APPLE)
    # cmake is complaining about LINK_PRIVATE in original PR
    # and removing it does not seem to hurt, so be it.
    # target_link_libraries(bench LINK_PRIVATE rt)
    foreach(example ${EXAMPLES})
        target_link_libraries(${example} rt)
    endforeach()
endif()

foreach(example ${EXAMPLES})
    target_link_libraries(${example} blosc_testing)
endforeach()

# tests
if(BUILD_TESTS)
    option(TEST_INCLUDE_EXAMPLES "Include examples in the tests" ON)
    if(TEST_INCLUDE_EXAMPLES)
        foreach(example ${EXAMPLES})
            if(example STREQUAL compress_file)
                add_test(NAME test_example_${example}
                    COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:${example}>
                        "${PROJECT_BINARY_DIR}/CMakeCache.txt" CMakeCache.b2frame)
            else()
                add_test(NAME test_example_${example}
                    COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:${example}>)
            endif()
        endforeach()
    endif()
endif()

## c-blosc2 2.12.0+ds

=== debian/changelog ===
c-blosc2 (2.12.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update symbol file.
  * Update the d/copyright file.
  * debian/patches:
    - Refresh all patches.
  * debian/control:
    - Add build dependency on libgrok-dev.
  * Upload to unstable.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 30 Dec 2023 14:39:17 +0000

c-blosc2 (2.11.2+ds-1~exp1) experimental; urgency=medium

  * Initial release (Closes: #1038443).

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sun, 18 Jun 2023 15:16:54 +0000

=== debian/control ===
Source: c-blosc2
Priority: optional
Section: libs
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Antonio Valentino <antonio.valentino@tiscali.it>
Build-Depends: debhelper-compat (= 13),
               cmake,
               dh-cmake-compat (= 1),
               dh-sequence-cmake,
               dh-sequence-sphinxdoc,
               dh-sequence-pkgkde-symbolshelper,
               libgrok-dev,
               liblz4-dev,
               pkg-kde-tools,
               zlib1g-dev,
               libzstd-dev,
               python3-breathe <!nodoc>,
               python3-pydata-sphinx-theme <!nodoc>,
               python3-sphinx <!nodoc>
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://blosc.org/
Vcs-Browser: https://salsa.debian.org/science-team/c-blosc2
Vcs-Git: https://salsa.debian.org/science-team/c-blosc2.git
Description: Fast, compressed, persistent binary data store library for C
 Blosc is a high performance compressor optimized for binary data. It has been
 designed to transmit data to the processor cache faster than the traditional,
 non-compressed, direct memory fetch approach via a memcpy() OS call. Blosc
 main goal is not just to reduce the size of large datasets on-disk or
 in-memory, but also to accelerate memory-bound computations.
 .
 C-Blosc2 is the new major version of C-Blosc, and tries hard to be backward
 compatible with both the C-Blosc1 API and its in-memory format. However, the
 reverse thing is generally not true for the format; buffers generated with
 C-Blosc2 are not format-compatible with C-Blosc1 (i.e. forward compatibility
 is not supported). In case you want to ensure full API compatibility with
 C-Blosc1 API, define the BLOSC1_COMPAT symbol.


Package: libblosc2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libblosc2-2 (= ${binary:Version}),
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package contains the development files required to build programs against
 Blosc2.

Package: libblosc2-2
Multi-Arch: same
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis}
 ${source:Extended-Description}

## c-blosc2 2.13.1+ds

=== debian/changelog ===
c-blosc2 (2.13.1+ds-1.1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:46:33 +0000

c-blosc2 (2.13.1+ds-1.1ubuntu1) noble; urgency=medium

  * Merge with Debian; remaining changes:
    - Patch set_values in blosc2 to just call memcpy if BLOSC_STRICT_ALIGN is
      set, fixing build on Ubuntu armhf.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Mar 2024 15:25:14 +0100

c-blosc2 (2.13.1+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062033

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 05:33:18 +0000

c-blosc2 (2.13.1+ds-1ubuntu1) noble; urgency=medium

  * Patch set_values in blosc2 to just call memcpy if BLOSC_STRICT_ALIGN is
    set, fixing build on Ubuntu armhf.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 12 Feb 2024 10:09:09 +1300

c-blosc2 (2.13.1+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 27 Jan 2024 12:02:41 +0000

c-blosc2 (2.12.0+ds-2) unstable; urgency=medium

  * Update dates in d/copyright.
  * debian/control:
    - Remove unneeded dependency on libgrok-dev.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 20 Jan 2024 10:52:13 +0000

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: c-blosc2
 Priority: optional
 Section: libs
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Antonio Valentino <antonio.valentino@tiscali.it>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                cmake,
                dh-cmake-compat (= 1),
                dh-sequence-cmake,
                dh-sequence-sphinxdoc,
                dh-sequence-pkgkde-symbolshelper,
-               libgrok-dev,
                liblz4-dev,
                pkg-kde-tools,
                zlib1g-dev,
@@ -41,7 +41,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libblosc2-2 (= ${binary:Version}),
+Depends: libblosc2-2t64 (= ${binary:Version}),
          ${misc:Depends},
          ${sphinxdoc:Depends}
 Description: ${source:Synopsis} (development files)
@@ -50,7 +50,10 @@
  This package contains the development files required to build programs against
  Blosc2.
 
-Package: libblosc2-2
+Package: libblosc2-2t64
+Provides: ${t64:Provides}
+Replaces: libblosc2-2
+Breaks: libblosc2-2 (<< ${source:Version})
 Multi-Arch: same
 Architecture: any
 Depends: ${shlibs:Depends},

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,+bindnow
include /usr/share/dpkg/pkg-info.mk

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Testsuite started to fail on mips64el, possibly related to switch
# from GCC-10 to GCC-11. Tested that both -O1 and -O3 optimization
# worked. -O2 was successful only when disabling inline functions.
# See bug #1000953
ifeq ($(DEB_HOST_ARCH),mips64el)
	export DEB_CFLAGS_MAINT_APPEND = -O1
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BINARY_DIR=debian/tmp \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DDEACTIVATE_AVX2=ON \
	-DDEACTIVATE_AVX512=ON \
	-DPREFER_EXTERNAL_LZ4=ON \
	-DPREFER_EXTERNAL_ZSTD=ON \
	-DPREFER_EXTERNAL_ZLIB=ON

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0

override_dh_auto_test:
	dh_auto_test -- ARGS=--verbose --jobs=1

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_NOTES.md

## c-blosc2 2.14.4+ds

=== blosc/CMakeLists.txt ===
# Blosc - Blocked Shuffling and Compression Library
#
# Copyright (c) 2021  Blosc Development Team <blosc@blosc.org>
# https://blosc.org
# License: BSD 3-Clause (see LICENSE.txt)
#
# See LICENSE.txt for details about copyright and rights to use.

# A simple way to detect that we are using CMAKE
add_definitions(-DUSING_CMAKE)

set(version_string ${BLOSC2_VERSION_MAJOR}.${BLOSC2_VERSION_MINOR}.${BLOSC2_VERSION_PATCH})

# targets
if(BUILD_SHARED)
    add_library(blosc2_shared SHARED)
    # ALIAS for superbuilds that use Blosc2 as sub-project
    # must be the same as the NAMESPACE in Blosc2Targets
    add_library(Blosc2::blosc2_shared ALIAS blosc2_shared)
    set_target_properties(blosc2_shared PROPERTIES
        OUTPUT_NAME blosc2
        # Hide symbols by default unless they're specifically exported.
        # This makes it easier to keep the set of exported symbols the
        # same across all compilers/platforms.
        C_VISIBILITY_PRESET hidden
    )
    if(MSVC OR MINGW)
        set_target_properties(blosc2_shared PROPERTIES PREFIX lib)
    endif()
    set_target_properties(blosc2_shared PROPERTIES
        VERSION ${version_string}
        SOVERSION 3  # Change this when an ABI change happens
    )
    target_compile_definitions(blosc2_shared PUBLIC BLOSC_SHARED_LIBRARY)
    target_include_directories(blosc2_shared PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:include>)
endif()
if(BUILD_STATIC)
    add_library(blosc2_static STATIC)
    # ALIAS for superbuilds that use Blosc2 as sub-project
    # must be the same as the NAMESPACE in Blosc2Targets
    add_library(Blosc2::blosc2_static ALIAS blosc2_static)
    set_target_properties(blosc2_static PROPERTIES
        OUTPUT_NAME blosc2
        POSITION_INDEPENDENT_CODE ON
        # Hide symbols by default unless they're specifically exported.
        # This makes it easier to keep the set of exported symbols the
        # same across all compilers/platforms.
        C_VISIBILITY_PRESET hidden
    )
    if(MSVC OR MINGW)
        set_target_properties(blosc2_static PROPERTIES PREFIX lib)
    endif()
    target_include_directories(blosc2_static PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:include>)
endif()
# When the option has been selected to compile the test suite,
# compile an additional version of blosc2_static which exports
# some normally-hidden symbols (to facilitate unit testing).
if(BUILD_TESTS)
    add_library(blosc_testing STATIC)
    set_target_properties(blosc_testing PROPERTIES OUTPUT_NAME blosc_testing)
    if(MSVC OR MINGW)
        set_target_properties(blosc_testing PROPERTIES PREFIX lib)
    endif()
    target_compile_definitions(blosc_testing PUBLIC
        BLOSC_TESTING
        BLOSC_SHARED_LIBRARY  # for EXPORT macro
    )
    target_include_directories(blosc_testing PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:include>)
endif()

set(INTERNAL_LIBS ${PROJECT_SOURCE_DIR}/internal-complibs)

# link dependencies
#   "link" dependent targets via target_link_libraries (preferred) and
#   manually add includes / libs for others
if(LZ4_FOUND)
    if(BUILD_SHARED)
        target_include_directories(blosc2_shared PUBLIC ${LZ4_INCLUDE_DIR})
    endif()
    if(BUILD_STATIC)
        target_include_directories(blosc2_static PUBLIC ${LZ4_INCLUDE_DIR})
    endif()
    if(BUILD_TESTS)
        target_include_directories(blosc_testing PUBLIC ${LZ4_INCLUDE_DIR})
    endif()
else()
    set(LZ4_LOCAL_DIR ${INTERNAL_LIBS}/lz4-1.9.4)
    if(BUILD_SHARED)
        target_include_directories(blosc2_shared PRIVATE ${LZ4_LOCAL_DIR})
    endif()
    if(BUILD_STATIC)
        target_include_directories(blosc2_static PRIVATE ${LZ4_LOCAL_DIR})
    endif()
    if(BUILD_TESTS)
        target_include_directories(blosc_testing PRIVATE ${LZ4_LOCAL_DIR})
    endif()
endif()

if(NOT DEACTIVATE_ZLIB)
    if(ZLIB_NG_FOUND)
        if(BUILD_SHARED)
            target_link_libraries(blosc2_shared PUBLIC ZLIB_NG::ZLIB_NG)
        endif()
        if(BUILD_STATIC)
            target_link_libraries(blosc2_static PUBLIC ZLIB_NG::ZLIB_NG)
        endif()
        if(BUILD_TESTS)
            target_link_libraries(blosc_testing PUBLIC ZLIB_NG::ZLIB_NG)
        endif()
    elseif(ZLIB_FOUND)
        if(BUILD_SHARED)
            target_link_libraries(blosc2_shared PUBLIC ZLIB::ZLIB)
        endif()
        if(BUILD_STATIC)
            target_link_libraries(blosc2_static PUBLIC ZLIB::ZLIB)
        endif()
        if(BUILD_TESTS)
            target_link_libraries(blosc_testing PUBLIC ZLIB::ZLIB)
        endif()
    else()
        set(ZLIB_LOCAL_DIR ${INTERNAL_LIBS}/${ZLIB_NG_DIR})
        if(BUILD_SHARED)
            target_include_directories(blosc2_shared PRIVATE ${ZLIB_LOCAL_DIR})
        endif()
        if(BUILD_STATIC)
            target_include_directories(blosc2_static PRIVATE ${ZLIB_LOCAL_DIR})
        endif()
        if(BUILD_TESTS)
            target_include_directories(blosc_testing PRIVATE ${ZLIB_LOCAL_DIR})
        endif()
    endif()
endif()

if(NOT DEACTIVATE_ZSTD)
    if(ZSTD_FOUND)
        if(BUILD_SHARED)
            target_include_directories(blosc2_shared PUBLIC ${ZSTD_INCLUDE_DIR})
            target_link_libraries(blosc2_shared PUBLIC ${ZSTD_LIBRARY})
        endif()
        if(BUILD_STATIC)
            target_include_directories(blosc2_static PUBLIC ${ZSTD_INCLUDE_DIR})
            target_link_libraries(blosc2_static PUBLIC ${ZSTD_LIBRARY})
        endif()
        if(BUILD_TESTS)
            target_include_directories(blosc_testing PUBLIC ${ZSTD_INCLUDE_DIR})
            target_link_libraries(blosc_testing PUBLIC ${ZSTD_LIBRARY})
        endif()
    else()
        set(ZSTD_LOCAL_DIR ${INTERNAL_LIBS}/zstd-1.5.5)
        if(BUILD_SHARED)
            target_include_directories(blosc2_shared PRIVATE ${ZSTD_LOCAL_DIR} ${ZSTD_LOCAL_DIR}/common)
        endif()
        if(BUILD_STATIC)
            target_include_directories(blosc2_static PRIVATE ${ZSTD_LOCAL_DIR} ${ZSTD_LOCAL_DIR}/common)
        endif()
        if(BUILD_TESTS)
            target_include_directories(blosc_testing PRIVATE ${ZSTD_LOCAL_DIR} ${ZSTD_LOCAL_DIR}/common)
        endif()
    endif()
endif()

# Threads
if(HAVE_THREADS)
    if(CMAKE_VERSION VERSION_LESS 3.1)
        set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
    else()
        set(LIBS ${LIBS} Threads::Threads)
    endif()
elseif(WIN32)
    message(STATUS "using the internal pthread library for win32 systems.")
    list(APPEND SOURCES blosc/win32/pthread.c)
else()
    message(FATAL_ERROR "Threads required but not found.")
endif()

# dlopen/dlclose
if(NOT WIN32)
    set(LIBS ${LIBS} ${CMAKE_DL_LIBS})
endif()

if(LZ4_FOUND)
    set(LIBS ${LIBS} ${LZ4_LIBRARY})
else()
    file(GLOB LZ4_FILES ${LZ4_LOCAL_DIR}/*.c)
    list(APPEND SOURCES ${LZ4_FILES})
    source_group("LZ4" FILES ${LZ4_FILES})
endif()

if(NOT DEACTIVATE_ZLIB)
    if(ZLIB_NG_FOUND)
        set(LIBS ${LIBS} ${ZLIB_NG_LIBRARY})
    elseif(ZLIB_FOUND)
        set(LIBS ${LIBS} ${ZLIB_LIBRARIES})
    else()
        set(ZLIB_LOCAL_DIR ${INTERNAL_LIBS}/${ZLIB_NG_DIR})
        file(GLOB ZLIB_FILES ${ZLIB_LOCAL_DIR}/*.c)
        list(APPEND SOURCES ${ZLIB_FILES})
        source_group("Zlib" FILES ${ZLIB_FILES})
    endif()
endif()

if(NOT DEACTIVATE_ZSTD)
    if(ZSTD_FOUND)
        set(LIBS ${LIBS} ${ZSTD_LIBRARY})
    else()
        # Enable assembly code only when not using MSVC *and* x86 is there
        if((NOT MSVC) AND COMPILER_SUPPORT_SSE2)   # if SSE2 is here, this is an x86 platform
            message(STATUS "Adding support for assembly sources in ZSTD")
            file(GLOB ZSTD_DECOMPRESS_FILES ${ZSTD_LOCAL_DIR}/decompress/*.S)
        else()
            message(STATUS "Disabling support for assembly sources in ZSTD")
            add_compile_definitions("ZSTD_DISABLE_ASM")
        endif()
        file(GLOB ZSTD_DECOMPRESS_FILES ${ZSTD_DECOMPRESS_FILES}
                ${ZSTD_LOCAL_DIR}/decompress/*.c)
        file(GLOB ZSTD_COMMON_FILES ${ZSTD_LOCAL_DIR}/common/*.c)
        file(GLOB ZSTD_COMPRESS_FILES ${ZSTD_LOCAL_DIR}/compress/*.c)
        file(GLOB ZSTD_DICT_FILES ${ZSTD_LOCAL_DIR}/dictBuilder/*.c)
        set(ZSTD_FILES ${ZSTD_COMMON_FILES} ${ZSTD_COMPRESS_FILES}
            ${ZSTD_DECOMPRESS_FILES} ${ZSTD_DICT_FILES})
        list(APPEND SOURCES ${ZSTD_FILES})
        source_group("Zstd" FILES ${ZSTD_FILES})
    endif()
endif()

if(HAVE_IPP)
    set(LIBS ${LIBS} "${IPP_LIBRARIES}")
endif()

if(UNIX AND NOT APPLE)
    set(LIBS ${LIBS} "rt")
    set(LIBS ${LIBS} "m")
    # set(LIBS ${LIBS} "profiler")
endif()


# Blosc2 library source files
list(APPEND SOURCES
    blosc/blosc2.c
    blosc/blosclz.c
    blosc/fastcopy.c
    blosc/fastcopy.h
    blosc/schunk.c
    blosc/frame.c
    blosc/stune.c
    blosc/stune.h
    blosc/context.h
    blosc/delta.c
    blosc/delta.h
    blosc/shuffle-generic.c
    blosc/bitshuffle-generic.c
    blosc/trunc-prec.c
    blosc/trunc-prec.h
    blosc/timestamp.c
    blosc/sframe.c
    blosc/directories.c
    blosc/blosc2-stdio.c
    blosc/b2nd.c
    blosc/b2nd_utils.c
)
if(NOT CMAKE_SYSTEM_PROCESSOR STREQUAL arm64)
    if(COMPILER_SUPPORT_SSE2)
        message(STATUS "Adding run-time support for SSE2")
        list(APPEND SOURCES blosc/shuffle-sse2.c blosc/bitshuffle-sse2.c)
    endif()
    if(COMPILER_SUPPORT_AVX2)
        message(STATUS "Adding run-time support for AVX2")
        list(APPEND SOURCES blosc/shuffle-avx2.c blosc/bitshuffle-avx2.c)
    endif()
    if(COMPILER_SUPPORT_AVX512)
        message(STATUS "Adding run-time support for AVX512")
        list(APPEND SOURCES blosc/bitshuffle-avx512.c)
    endif()
endif()
if(COMPILER_SUPPORT_NEON)
    message(STATUS "Adding run-time support for NEON")
    # bitshuffle-neon.c does not offer better speed than generic on arm64 (Mac M1).
    # Besides, it does not compile on raspberry pi (armv7l), so disable it.
    list(APPEND SOURCES blosc/shuffle-neon.c)  # blosc/bitshuffle-neon.c)
endif()
if(COMPILER_SUPPORT_ALTIVEC)
    message(STATUS "Adding run-time support for ALTIVEC")
    list(APPEND SOURCES blosc/shuffle-altivec.c blosc/bitshuffle-altivec.c)
endif()
list(APPEND SOURCES blosc/shuffle.c)

# Based on the target architecture and hardware features supported
# by the C compiler, set hardware architecture optimization flags
# for specific shuffle implementations.
if(COMPILER_SUPPORT_SSE2)
    if(MSVC)
        # MSVC targets SSE2 by default on 64-bit configurations, but not 32-bit configurations.
        if(${CMAKE_SIZEOF_VOID_P} EQUAL 4)
            set_source_files_properties(
                    shuffle-sse2.c bitshuffle-sse2.c blosclz.c fastcopy.c
                    PROPERTIES COMPILE_OPTIONS "/arch:SSE2")
            set_property(
                    SOURCE shuffle.c
                    APPEND PROPERTY COMPILE_OPTIONS "/arch:SSE2")
        endif()
    else()
        set_source_files_properties(
                shuffle-sse2.c bitshuffle-sse2.c blosclz.c fastcopy.c
                PROPERTIES COMPILE_OPTIONS -msse2)
        set_property(
                SOURCE shuffle.c
                APPEND PROPERTY COMPILE_OPTIONS -msse2)
        # Add SIMD flags for the bytedelta filter and Intel (it seems that ARM64 does not need these)
        set_source_files_properties(
                ${PROJECT_SOURCE_DIR}/plugins/filters/bytedelta/bytedelta.c
                PROPERTIES COMPILE_OPTIONS "-mssse3")
    endif()

    # Define a symbol for the shuffle-dispatch implementation
    # so it knows SSE2 is supported even though that file is
    # compiled without SSE2 support (for portability).
    set_property(
            SOURCE shuffle.c
            APPEND PROPERTY COMPILE_DEFINITIONS SHUFFLE_SSE2_ENABLED)

endif()
if(COMPILER_SUPPORT_AVX2)
    if(MSVC)
        set_source_files_properties(
                shuffle-avx2.c bitshuffle-avx2.c
                PROPERTIES COMPILE_OPTIONS "/arch:AVX2")
        set_property(
                SOURCE shuffle.c

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Examples with correspondingly named source files
 set(EXAMPLES contexts instrument_codec delta_schunk_ex multithread simple frame_metalayers
     noinit find_roots schunk_simple frame_simple schunk_postfilter urcodecs urfilters frame_vlmetalayers
-    sframe_simple frame_backed_schunk compress_file frame_offset frame_roundtrip get_set_slice get_blocksize)
+    sframe_simple frame_backed_schunk compress_file decompress_file frame_offset frame_roundtrip get_set_slice get_blocksize)
 
 add_subdirectory(b2nd)
 
@@ -44,8 +44,12 @@
         foreach(example ${EXAMPLES})
             if(example STREQUAL compress_file)
                 add_test(NAME test_example_${example}
-                    COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:${example}>
-                        "${PROJECT_BINARY_DIR}/CMakeCache.txt" CMakeCache.b2frame)
+                         COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:${example}>
+                         "${PROJECT_BINARY_DIR}/CMakeCache.txt" CMakeCache.b2frame)
+            elseif(example STREQUAL decompress_file)
+                add_test(NAME test_example_${example}
+                         COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:${example}>
+                         CMakeCache.b2frame CMakeCache-2.txt)
             else()
                 add_test(NAME test_example_${example}
                     COMMAND ${CMAKE_CROSSCOMPILING_EMULATOR} $<TARGET_FILE:${example}>)

=== plugins/CMakeLists.txt ===
# Blosc - Blocked Shuffling and Compression Library
#
# Copyright (c) 2021  Blosc Development Team <blosc@blosc.org>
# https://blosc.org
# License: BSD 3-Clause (see LICENSE.txt)
#
# See LICENSE.txt for details about copyright and rights to use.

add_subdirectory(codecs)
add_subdirectory(tuners)
add_subdirectory(filters)

set(SOURCES ${SOURCES} ${PROJECT_SOURCE_DIR}/plugins/plugin_utils.c PARENT_SCOPE)

=== debian/changelog ===
c-blosc2 (2.14.4+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 01 Jun 2024 11:14:40 +0000

c-blosc2 (2.14.4+ds-1) experimental; urgency=medium

  [ Michael R. Crusoe ]
  * New upstream version
  * Removed two patches applied upstream: 0002-Fixes-for-CVE-2024-3204-
    and-CVE-2024-3203.patch and 0004-Fix-bus-error-on-armhf.patch

  [ Antonio Valentino ]
  * debian/patches:
    - Renumber remaining patches.
  * Update d/copyright.
  * Update symbol file.
  * SO version bump.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 25 May 2024 20:10:17 +0000

c-blosc2 (2.13.1+ds-5) unstable; urgency=medium

  * debian/patches:
    - New 0004-Fix-bus-error-on-armhf.patch (Closes: #1063358).

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Fri, 10 May 2024 14:03:12 +0000

c-blosc2 (2.13.1+ds-4) unstable; urgency=medium

  * debian/patches:
    - New 0003-Missing-headers.patch (Closes: #1070747).

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Fri, 10 May 2024 07:53:21 +0000

c-blosc2 (2.13.1+ds-3) unstable; urgency=medium

  * debian/patches:
    - New Fixes-for-CVE-2024-3204-and-CVE-2024-3203,
      for fixing two critical security issues.
      Backported from upstream
      https://github.com/Blosc/c-blosc2/commit/892f6d9c.
  * Rely on pre-initialized dpkg-architecture variables.
  * Drop changes in experimental and upload a security fix
    to unstable.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 06 Apr 2024 15:56:04 +0000

c-blosc2 (2.13.1+ds-2) experimental; urgency=medium

  * Update symbol file.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 03 Feb 2024 08:19:10 +0000

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: c-blosc2
 Priority: optional
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Antonio Valentino <antonio.valentino@tiscali.it>
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5),
+               debhelper-compat (= 13),
                cmake,
                dh-cmake-compat (= 1),
                dh-sequence-cmake,
@@ -41,19 +41,17 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libblosc2-2t64 (= ${binary:Version}),
-         ${misc:Depends},
-         ${sphinxdoc:Depends}
+Depends: libblosc2-3 (= ${binary:Version}),
+         ${misc:Depends}
 Description: ${source:Synopsis} (development files)
  ${source:Extended-Description}
  .
  This package contains the development files required to build programs against
  Blosc2.
 
-Package: libblosc2-2t64
+Package: libblosc2-3
+X-Time64-Compat: libblosc2-3
 Provides: ${t64:Provides}
-Replaces: libblosc2-2
-Breaks: libblosc2-2 (<< ${source:Version})
 Multi-Arch: same
 Architecture: any
 Depends: ${shlibs:Depends},

## c-blosc2 2.15.0+ds

=== debian/changelog ===
c-blosc2 (2.15.0+ds-1) unstable; urgency=medium

  * Upload to unstable.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sun, 14 Jul 2024 18:23:22 +0000

c-blosc2 (2.15.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update d/copyright.
  * debian/patches:
    - Drop 0002-Missing-headers.patch, applied upstream.
  * Update the package according to the new soname.
  * Update symbol file.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 06 Jul 2024 09:52:29 +0000

=== debian/control ===
--- 
+++ 
@@ -41,7 +41,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libblosc2-3 (= ${binary:Version}),
+Depends: libblosc2-4 (= ${binary:Version}),
          ${misc:Depends}
 Description: ${source:Synopsis} (development files)
  ${source:Extended-Description}
@@ -49,8 +49,8 @@
  This package contains the development files required to build programs against
  Blosc2.
 
-Package: libblosc2-3
-X-Time64-Compat: libblosc2-3
+Package: libblosc2-4
+X-Time64-Compat: libblosc2-4
 Provides: ${t64:Provides}
 Multi-Arch: same
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 CXXFLAGS+=$(CPPFLAGS)
 
 UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
-DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
+include /usr/share/dpkg/architecture.mk
 
 # Testsuite started to fail on mips64el, possibly related to switch
 # from GCC-10 to GCC-11. Tested that both -O1 and -O3 optimization

## c-blosc2 2.15.1+ds

=== debian/changelog ===
c-blosc2 (2.15.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.0, no changes.
  * Update symbol file.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Tue, 30 Jul 2024 20:16:34 +0000

## c-blosc2 2.15.2+ds

=== debian/changelog ===
c-blosc2 (2.15.2+ds-5) unstable; urgency=medium

  * Team upload
  * Revert "Restrict the list of supported platforms"

 -- Bastian Germann <bage@eberlin.debian.org>  Fri, 03 Jan 2025 20:10:16 +0000

c-blosc2 (2.15.2+ds-4) unstable; urgency=medium

  * debian/control:
    - Update the architecture field of libblosc2-dev.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Thu, 26 Dec 2024 14:05:30 +0000

c-blosc2 (2.15.2+ds-3) unstable; urgency=medium

  * debian/control:
    - Restrict the list of supported platforms (exclude mips64el).
  * debian/patches:
    - Revert 0002-Fix-broken-tests-on-mips64el.patch.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Thu, 26 Dec 2024 10:03:33 +0000

c-blosc2 (2.15.2+ds-2) unstable; urgency=medium

  * debian/patches:
    - New 0002-Fix-broken-tests-on-mips64el.patch.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Fri, 20 Dec 2024 18:37:11 +0000

c-blosc2 (2.15.2+ds-1) unstable; urgency=medium

  * New upstream version.
  * debian/patches:
    - Refresh all patches.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Wed, 04 Dec 2024 01:35:58 +0000

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
                python3-breathe <!nodoc>,
                python3-pydata-sphinx-theme <!nodoc>,
                python3-sphinx <!nodoc>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://blosc.org/
 Vcs-Browser: https://salsa.debian.org/science-team/c-blosc2

=== debian/rules ===
--- 
+++ 
@@ -11,14 +11,6 @@
 
 UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')
 include /usr/share/dpkg/architecture.mk
-
-# Testsuite started to fail on mips64el, possibly related to switch
-# from GCC-10 to GCC-11. Tested that both -O1 and -O3 optimization
-# worked. -O2 was successful only when disabling inline functions.
-# See bug #1000953
-ifeq ($(DEB_HOST_ARCH),mips64el)
-	export DEB_CFLAGS_MAINT_APPEND = -O1
-endif
 
 %:
 	dh $@

## c-blosc2 2.16.0%2Bds

=== bench/b2nd/CMakeLists.txt ===
# Blosc - Blocked Shuffling and Compression Library
#
# Copyright (c) 2021  Blosc Development Team <blosc@blosc.org>
# https://blosc.org
# License: BSD 3-Clause (see LICENSE.txt)
#
# See LICENSE.txt for details about copyright and rights to use.

file(GLOB SOURCES bench_*.c)

foreach (source ${SOURCES})
    get_filename_component(target_name ${source} NAME_WE)
    set(target b2nd_${target_name})
    add_executable(${target} ${target_name}.c)
    target_link_libraries(${target} PUBLIC blosc_testing ${LIBS})
endforeach (source)

## c-blosc2 2.16.0+ds

=== blosc/CMakeLists.txt ===
--- 
+++ 
@@ -29,14 +29,16 @@
     endif()
     set_target_properties(blosc2_shared PROPERTIES
         VERSION ${version_string}
-        SOVERSION 3  # Change this when an ABI change happens
+        SOVERSION 4  # Change this when an ABI change happens
     )
     target_compile_definitions(blosc2_shared PUBLIC BLOSC_SHARED_LIBRARY)
+    target_include_directories(blosc2_shared PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
     target_include_directories(blosc2_shared PUBLIC
-        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
         $<INSTALL_INTERFACE:include>)
 endif()
 if(BUILD_STATIC)
+    add_compile_definitions(BUILD_STATIC)
     add_library(blosc2_static STATIC)
     # ALIAS for superbuilds that use Blosc2 as sub-project
     # must be the same as the NAMESPACE in Blosc2Targets
@@ -52,8 +54,9 @@
     if(MSVC OR MINGW)
         set_target_properties(blosc2_static PROPERTIES PREFIX lib)
     endif()
+    target_include_directories(blosc2_static PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
     target_include_directories(blosc2_static PUBLIC
-        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
         $<INSTALL_INTERFACE:include>)
 endif()
 # When the option has been selected to compile the test suite,
@@ -90,7 +93,7 @@
         target_include_directories(blosc_testing PUBLIC ${LZ4_INCLUDE_DIR})
     endif()
 else()
-    set(LZ4_LOCAL_DIR ${INTERNAL_LIBS}/lz4-1.9.4)
+    set(LZ4_LOCAL_DIR ${INTERNAL_LIBS}/lz4-1.10.0)
     if(BUILD_SHARED)
         target_include_directories(blosc2_shared PRIVATE ${LZ4_LOCAL_DIR})
     endif()
@@ -152,7 +155,7 @@
             target_link_libraries(blosc_testing PUBLIC ${ZSTD_LIBRARY})
         endif()
     else()
-        set(ZSTD_LOCAL_DIR ${INTERNAL_LIBS}/zstd-1.5.5)
+        set(ZSTD_LOCAL_DIR ${INTERNAL_LIBS}/zstd-1.5.6)
         if(BUILD_SHARED)
             target_include_directories(blosc2_shared PRIVATE ${ZSTD_LOCAL_DIR} ${ZSTD_LOCAL_DIR}/common)
         endif()
@@ -300,17 +303,11 @@
             set_source_files_properties(
                     shuffle-sse2.c bitshuffle-sse2.c blosclz.c fastcopy.c
                     PROPERTIES COMPILE_OPTIONS "/arch:SSE2")
-            set_property(
-                    SOURCE shuffle.c
-                    APPEND PROPERTY COMPILE_OPTIONS "/arch:SSE2")
         endif()
     else()
         set_source_files_properties(
                 shuffle-sse2.c bitshuffle-sse2.c blosclz.c fastcopy.c
                 PROPERTIES COMPILE_OPTIONS -msse2)
-        set_property(
-                SOURCE shuffle.c
-                APPEND PROPERTY COMPILE_OPTIONS -msse2)
         # Add SIMD flags for the bytedelta filter and Intel (it seems that ARM64 does not need these)
         set_source_files_properties(
                 ${PROJECT_SOURCE_DIR}/plugins/filters/bytedelta/bytedelta.c
@@ -330,5 +327,5 @@
         set_source_files_properties(
                 shuffle-avx2.c bitshuffle-avx2.c
                 PROPERTIES COMPILE_OPTIONS "/arch:AVX2")
-        set_property(
-                SOURCE shuffle.c
+    else()
+        set_source_files_properties(

=== debian/changelog ===
c-blosc2 (2.16.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright:
    - Drop no longer needed entries in Files-Excluded.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 15 Feb 2025 18:01:50 +0000

c-blosc2 (2.15.2+ds-6) unstable; urgency=medium

  * Update dates in d/copyright.
  * debian/rules:
    - Skip tests on mips64el.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 25 Jan 2025 17:59:06 +0000

## c-blosc2 2.17.0+ds

=== debian/changelog ===
c-blosc2 (2.17.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update symbol file.

 -- Antonio Valentino <antonio.valentino@tiscali.it>  Sat, 01 Mar 2025 11:06:40 +0000
